#include(model4.macros)

[TOP]
components : t2Cons@Consumer
components : t2
components : t1Gen@Generator
components : t1
components : c1
link : y-co-hayauto03@t2 x-t-hayauto0@t2Cons 
link : y-co-hayauto13@t2 x-t-hayauto1@t2Cons 
link : y-t-hayauto0@t1Gen x-ge-hayauto00@t1
link : y-t-hayauto1@t1Gen x-ge-hayauto10@t1
link : y-t-haylugar2@c1 x-c-haylugar03@t1                
link : y-t-haylugar3@c1 x-c-haylugar13@t1                
link : y-c-hayauto03@t1 x-t-hayauto2@c1 
link : y-c-hayauto13@t1 x-t-hayauto3@c1 
link : y-t-hayauto0@c1 x-c-hayauto00@t2
link : y-t-hayauto1@c1 x-c-hayauto10@t2
link : y-c-haylugar00@t2 x-t-haylugar0@c1 
link : y-c-haylugar10@t2 x-t-haylugar1@c1 

[t2]
type : cell
width : 4
height : 2
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : t2(1,-1)  t2(1,0)  t2(1,1)
neighbors : t2(0,-1)  t2(0,0)  t2(0,1)
neighbors : t2(-1,-1) t2(-1,0) t2(-1,1)
initialvalue : 0
in : x-c-hayauto00 
in : x-c-hayauto10 
out: y-c-haylugar00  
out: y-c-haylugar10  
out: y-co-hayauto03
out: y-co-hayauto13
link : x-c-hayauto00 x-c-hayauto@t2(0,0)
link : x-c-hayauto10 x-c-hayauto@t2(1,0)
link : y-c-haylugar@t2(0,0) y-c-haylugar00
link : y-c-haylugar@t2(1,0) y-c-haylugar10
link : y-co-hayauto@t2(0,3) y-co-hayauto03
link : y-co-hayauto@t2(1,3) y-co-hayauto13
localtransition : t2-segment2-lane0-rule
zone : t2-segment2-cell10-hole-rule {(1,0)}
zone : t2-segment2-cell11-hole-rule {(1,1)}
zone : t2-segment2-cell12-hole-rule {(1,2)}
zone : t2-segment2-cell13-hole-rule {(1,3)}
zone : t2-segment2-cell00-rule {(0,0)}
zone : t2-segment2-cell10-rule {(1,0)}
zone : t2-segment2-cell0n-rule {(0,3)}
zone : t2-segment2-cell1n-rule {(1,3)}
zone : t2-segment2-lane0-rule  {(0,1)..(0,3-1)}
zone : t2-segment2-lane1-rule  {(1,1)..(1,3-1)}


[t2Cons]
lanes=2


[t1]
type : cell
width : 4
height : 2
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : t1(1,-1)  t1(1,0)  t1(1,1)
neighbors : t1(0,-1)  t1(0,0)  t1(0,1)
neighbors : t1(-1,-1) t1(-1,0) t1(-1,1)
initialvalue : 0
in : x-ge-hayauto00 
in : x-ge-hayauto10 
in : x-c-haylugar03  
in : x-c-haylugar13  
out: y-c-hayauto03
out: y-c-hayauto13
link : x-ge-hayauto00 x-ge-hayauto@t1(0,0)
link : x-ge-hayauto10 x-ge-hayauto@t1(1,0)
link : x-c-haylugar03 x-c-haylugar@t1(0,3)
link : x-c-haylugar13 x-c-haylugar@t1(1,3)
link : y-c-hayauto@t1(0,3) y-c-hayauto03
link : y-c-hayauto@t1(1,3) y-c-hayauto13
localtransition : t1-segment2-lane0-rule
zone : t1-segment2-cell00-rule {(0,0)}
zone : t1-segment2-cell10-rule {(1,0)}
zone : t1-segment2-cell0n-rule {(0,3)}
zone : t1-segment2-cell1n-rule {(1,3)}
zone : t1-segment2-lane0-rule  {(0,1)..(0,3-1)}
zone : t1-segment2-lane1-rule  {(1,1)..(1,3-1)}


[t1Gen]
lanes=2


[c1]
type : cell
width : 4
height : 1
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : c1(0,-1) c1(0,0) c1(0,1)
initialvalue : 0
in : x-t-hayauto2
in : x-t-hayauto3
out: y-t-haylugar2
out: y-t-haylugar3
in : x-t-haylugar0
in : x-t-haylugar1
out: y-t-hayauto0 
out: y-t-hayauto1 
link : x-t-hayauto2 x-t-hayauto@c1(0,2)
link : x-t-hayauto3 x-t-hayauto@c1(0,3)
link : y-t-haylugar@c1(0,2) y-t-haylugar2
link : y-t-haylugar@c1(0,3) y-t-haylugar3
link : x-t-haylugar0 x-t-haylugar@c1(0,0)
link : x-t-haylugar1 x-t-haylugar@c1(0,1)
link : y-t-hayauto@c1(0,0) y-t-hayauto0
link : y-t-hayauto@c1(0,1) y-t-hayauto1
localtransition : c1-cellIn-rule
zone : c1-cellIn-hole-rule {(0,2)}
zone : c1-cellIn-hole-rule {(0,3)}
zone : c1-cellOut-hole-rule {(0,0)}
zone : c1-cellOut-hole-rule {(0,1)}

[t2-segment2-cell10-hole-rule]
#Macro(t2-Hole10-Llega_Desde_Cruce)
#Macro(t2-Hole10-Sale_Hacia_Adelante)
#Macro(t2-Hole10-Sale_Hacia_CarrilIz)
#Macro(t2-Hole10-Default)

[t2-segment2-cell11-hole-rule]
#Macro(t2-Hole11-Llega_Desde_Atras)
#Macro(t2-Hole11-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Hole11-Sale_Hacia_Adelante)
#Macro(t2-Hole11-Sale_Hacia_CarrilIz)
#Macro(t2-Hole11-Default)

[t2-segment2-cell12-hole-rule]
#Macro(t2-Hole12-Llega_Desde_Atras)
#Macro(t2-Hole12-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Hole12-Sale_Hacia_Adelante)
#Macro(t2-Hole12-Sale_Hacia_CarrilIz)
#Macro(t2-Hole12-Default)

[t2-segment2-cell13-hole-rule]
#Macro(t2-Hole13-Llega_Desde_Atras)
#Macro(t2-Hole13-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Hole13-Sale_Hacia_Cruce)
#Macro(t2-Hole13-Default)

[t2-segment2-cell00-rule]
#Macro(t2-Llega_Desde_Cruce)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilDer_ConPrioridad)
#Macro(t2-Default)

[t2-segment2-cell10-rule]
#Macro(t2-Llega_Desde_Cruce)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilIz)
#Macro(t2-Default)

[t2-segment2-cell0n-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilDer)
#Macro(t2-Sale_Hacia_Consumidor)
#Macro(t2-Default)

[t2-segment2-cell1n-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Sale_Hacia_Consumidor)
#Macro(t2-Default)

[t2-segment2-lane0-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilDer)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilDer_ConPrioridad)
#Macro(t2-Default)

[t2-segment2-lane1-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilIz)
#Macro(t2-Default)

[t1-segment2-cell00-rule]
#Macro(t1-Llega_Desde_Generador)
#Macro(t1-Sale_Hacia_Adelante)
#Macro(t1-Sale_Hacia_CarrilDer_ConPrioridad)
#Macro(t1-Default)

[t1-segment2-cell10-rule]
#Macro(t1-Llega_Desde_Generador)
#Macro(t1-Sale_Hacia_Adelante)
#Macro(t1-Sale_Hacia_CarrilIz)
#Macro(t1-Default)

[t1-segment2-cell0n-rule]
#Macro(t1-Llega_Desde_Atras)
#Macro(t1-Llega_Desde_CarrilDer)
#Macro(t1-Sale_Hacia_Cruce)
#Macro(t1-Default)

[t1-segment2-cell1n-rule]
#Macro(t1-Llega_Desde_Atras)
#Macro(t1-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t1-Sale_Hacia_Cruce)
#Macro(t1-Default)

[t1-segment2-lane0-rule]
#Macro(t1-Llega_Desde_Atras)
#Macro(t1-Llega_Desde_CarrilDer)
#Macro(t1-Sale_Hacia_Adelante)
#Macro(t1-Sale_Hacia_CarrilDer_ConPrioridad)
#Macro(t1-Default)

[t1-segment2-lane1-rule]
#Macro(t1-Llega_Desde_Atras)
#Macro(t1-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t1-Sale_Hacia_Adelante)
#Macro(t1-Sale_Hacia_CarrilIz)
#Macro(t1-Default)

[c1-cellIn-hole-rule]
rule : {1 + send(1, y-t-haylugar)}  221 { (0,0) = 0 and ( (0,-1) = 1 or portvalue(x-t-hayauto) = 1 ) }
rule : {0 + send(0, y-t-haylugar)}  221 { (0,0) = 1 and (0,1) = 0 and (0,-1) = 0 }
rule : {0 + send(1, y-t-haylugar)}  221 { (0,0) = 1 and (0,1) = 0 and (0,-1) = 1 }
rule : {(0,0)}  221 { t }

[c1-cellOut-hole-rule]
rule : {1 + send(0, y-t-hayauto)}  221 { (0,0) = 0 and (0,-1) = 1 and ( portvalue(x-t-haylugar) = 1 or (portvalue(x-t-haylugar) = 0 and random < 111)}
rule : {0 + send(1, y-t-hayauto)}  221 { (0,0) = 0 and (0,-1) = 1 and portvalue(x-t-haylugar) = 0 and random >= 111 }
rule : {0 + send(0, y-t-hayauto)}  221 { (0,0) = 1 and (0,1) = 0 }
rule : {(0,0) + send(0, y-t-hayauto)}  221 { t }

