#include(model7.macros)

[TOP]
components : t2tl@TrafficLight
components : t2Gen@Generator
components : t2
components : t4Cons@Consumer
components : t4
components : t5Cons@Consumer
components : t5
components : t3tl@TrafficLight
components : t3Gen@Generator
components : t3
components : c2stl@SincroTrafficLight
components : c2
link : y-t-luz0@t2tl x-se-luz03@t2                
link : y-t-luz1@t2tl x-se-luz13@t2                
link : y-t-hayauto0@t2Gen x-ge-hayauto00@t2
link : y-t-hayauto1@t2Gen x-ge-hayauto10@t2
link : y-co-hayauto04@t4 x-t-hayauto0@t4Cons 
link : y-co-hayauto05@t5 x-t-hayauto0@t5Cons 
link : y-t-luz0@t3tl x-se-luz01@t3                
link : y-t-hayauto0@t3Gen x-ge-hayauto00@t3
link : y-se-luz0@c2stl x-si-luz@t3tl
link : y-se-luz1@c2stl x-si-luz@t2tl
link : y-t-haylugar2@c2 x-c-haylugar01@t3                
link : y-t-haylugar3@c2 x-c-haylugar03@t2                
link : y-t-haylugar4@c2 x-c-haylugar13@t2                
link : y-c-hayauto01@t3 x-t-hayauto2@c2 
link : y-c-hayauto03@t2 x-t-hayauto3@c2 
link : y-c-hayauto13@t2 x-t-hayauto4@c2 
link : y-t-hayauto0@c2 x-c-hayauto00@t4
link : y-t-hayauto1@c2 x-c-hayauto00@t5
link : y-c-haylugar00@t4 x-t-haylugar0@c2 
link : y-c-haylugar00@t5 x-t-haylugar1@c2 

[t2]
type : cell
width : 4
height : 2
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : t2(1,-1)  t2(1,0)  t2(1,1)
neighbors : t2(0,-1)  t2(0,0)  t2(0,1)
neighbors : t2(-1,-1) t2(-1,0) t2(-1,1)
initialvalue : 0
in : x-se-luz03 
in : x-se-luz13 
in : x-ge-hayauto00 
in : x-ge-hayauto10 
in : x-c-haylugar03  
in : x-c-haylugar13  
out: y-c-hayauto03
out: y-c-hayauto13
link : x-se-luz03 x-se-luz@t2(0,3)
link : x-se-luz13 x-se-luz@t2(1,3)
link : x-ge-hayauto00 x-ge-hayauto@t2(0,0)
link : x-ge-hayauto10 x-ge-hayauto@t2(1,0)
link : x-c-haylugar03 x-c-haylugar@t2(0,3)
link : x-c-haylugar13 x-c-haylugar@t2(1,3)
link : y-c-hayauto@t2(0,3) y-c-hayauto03
link : y-c-hayauto@t2(1,3) y-c-hayauto13
localtransition : t2-segment2-lane0-rule
zone : t2-segment2-cell10-hole-rule {(1,0)}
zone : t2-segment2-cell11-hole-rule {(1,1)}
zone : t2-segment2-cell12-hole-rule {(1,2)}
zone : t2-segment2-cell13-hole-rule {(1,3)}
zone : t2-segment2-cell0n-semaforo-rule {(0,3)}
zone : t2-segment2-cell1n-semaforo-rule {(1,3)}
zone : t2-segment2-cell00-rule {(0,0)}
zone : t2-segment2-cell10-rule {(1,0)}
zone : t2-segment2-cell0n-rule {(0,3)}
zone : t2-segment2-cell1n-rule {(1,3)}
zone : t2-segment2-lane0-rule  {(0,1)..(0,3-1)}
zone : t2-segment2-lane1-rule  {(1,1)..(1,3-1)}


[t2tl]
lanes=2


[t2Gen]
lanes=2


[t4]
type : cell
width : 5
height : 1
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : t4(0,-1) t4(0,0) t4(0,1)
initialvalue : 0
in : x-c-hayauto00 
out: y-c-haylugar00  
out: y-co-hayauto04
link : x-c-hayauto00 x-c-hayauto@t4(0,0)
link : y-c-haylugar@t4(0,0) y-c-haylugar00
link : y-co-hayauto@t4(0,4) y-co-hayauto04
localtransition : t4-lane0-rule
zone : t4-segment1-cell00-rule {(0,0)}
zone : t4-segment1-cell0n-rule {(0,4)}
zone : t4-segment1-lane0-rule  {(0,1)..(0,4-1)}


[t4Cons]
lanes=1


[t5]
type : cell
width : 6
height : 1
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : t5(0,-1) t5(0,0) t5(0,1)
initialvalue : 0
in : x-c-hayauto00 
out: y-c-haylugar00  
out: y-co-hayauto05
link : x-c-hayauto00 x-c-hayauto@t5(0,0)
link : y-c-haylugar@t5(0,0) y-c-haylugar00
link : y-co-hayauto@t5(0,5) y-co-hayauto05
localtransition : t5-lane0-rule
zone : t5-segment1-cell00-rule {(0,0)}
zone : t5-segment1-cell0n-rule {(0,5)}
zone : t5-segment1-lane0-rule  {(0,1)..(0,5-1)}


[t5Cons]
lanes=1


[t3]
type : cell
width : 2
height : 1
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : t3(0,-1) t3(0,0) t3(0,1)
initialvalue : 0
in : x-se-luz01 
in : x-ge-hayauto00 
in : x-c-haylugar01  
out: y-c-hayauto01
link : x-se-luz01 x-se-luz@t3(0,1)
link : x-ge-hayauto00 x-ge-hayauto@t3(0,0)
link : x-c-haylugar01 x-c-haylugar@t3(0,1)
link : y-c-hayauto@t3(0,1) y-c-hayauto01
localtransition : t3-lane0-rule
zone : t3-segment1-cell0n-semaforo-rule {(0,1)}
zone : t3-segment1-cell00-rule {(0,0)}
zone : t3-segment1-cell0n-rule {(0,1)}
zone : t3-segment1-lane0-rule  {(0,1)..(0,1-1)}


[t3tl]
lanes=1


[t3Gen]
lanes=1


[c2]
type : cell
width : 5
height : 1
delay : transport
defaultDelayTime : 1
border : nowrapped
neighbors : c2(0,-1) c2(0,0) c2(0,1)
initialvalue : 0
in : x-t-hayauto2
in : x-t-hayauto3
in : x-t-hayauto4
out: y-t-haylugar2
out: y-t-haylugar3
out: y-t-haylugar4
in : x-t-haylugar0
in : x-t-haylugar1
out: y-t-hayauto0 
out: y-t-hayauto1 
link : x-t-hayauto2 x-t-hayauto@c2(0,2)
link : x-t-hayauto3 x-t-hayauto@c2(0,3)
link : x-t-hayauto4 x-t-hayauto@c2(0,4)
link : y-t-haylugar@c2(0,2) y-t-haylugar2
link : y-t-haylugar@c2(0,3) y-t-haylugar3
link : y-t-haylugar@c2(0,4) y-t-haylugar4
link : x-t-haylugar0 x-t-haylugar@c2(0,0)
link : x-t-haylugar1 x-t-haylugar@c2(0,1)
link : y-t-hayauto@c2(0,0) y-t-hayauto0
link : y-t-hayauto@c2(0,1) y-t-hayauto1
localtransition : c2-cellIn-rule
zone : c2-cellIn-rule  {(0,2)}
zone : c2-cellIn-rule  {(0,3)}
zone : c2-cellIn-rule  {(0,4)}
zone : c2-cellOut-rule {(0,0)}
zone : c2-cellOut-rule {(0,1)}


[c2stl]
tlights=2

[t2-segment2-cell10-hole-rule]
#Macro(t2-Hole10-Llega_Desde_Cruce)
#Macro(t2-Hole10-Sale_Hacia_Adelante)
#Macro(t2-Hole10-Sale_Hacia_CarrilIz)
#Macro(t2-Hole10-Default)

[t2-segment2-cell11-hole-rule]
#Macro(t2-Hole11-Llega_Desde_Atras)
#Macro(t2-Hole11-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Hole11-Sale_Hacia_Adelante)
#Macro(t2-Hole11-Sale_Hacia_CarrilIz)
#Macro(t2-Hole11-Default)

[t2-segment2-cell12-hole-rule]
#Macro(t2-Hole12-Llega_Desde_Atras)
#Macro(t2-Hole12-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Hole12-Sale_Hacia_Adelante)
#Macro(t2-Hole12-Sale_Hacia_CarrilIz)
#Macro(t2-Hole12-Default)

[t2-segment2-cell13-hole-rule]
#Macro(t2-Hole13-Llega_Desde_Atras)
#Macro(t2-Hole13-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Hole13-Sale_Hacia_Cruce)
#Macro(t2-Hole13-Default)

[t2-segment2-cell0n-semaforo-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilDer)
#Macro(t2-Sale_Hacia_Cruce_conSemaforo)
#Macro(t2-Default)

[t2-segment2-cell1n-semaforo-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Sale_Hacia_Cruce_conSemaforo)
#Macro(t2-Default)

[t2-segment2-cell00-rule]
#Macro(t2-Llega_Desde_Generador)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilDer_ConPrioridad)
#Macro(t2-Default)

[t2-segment2-cell10-rule]
#Macro(t2-Llega_Desde_Generador)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilIz)
#Macro(t2-Default)

[t2-segment2-cell0n-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilDer)
#Macro(t2-Sale_Hacia_Cruce)
#Macro(t2-Default)

[t2-segment2-cell1n-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Sale_Hacia_Cruce)
#Macro(t2-Default)

[t2-segment2-lane0-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilDer)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilDer_ConPrioridad)
#Macro(t2-Default)

[t2-segment2-lane1-rule]
#Macro(t2-Llega_Desde_Atras)
#Macro(t2-Llega_Desde_CarrilIz_ConPrioridad)
#Macro(t2-Sale_Hacia_Adelante)
#Macro(t2-Sale_Hacia_CarrilIz)
#Macro(t2-Default)

[t4-segment1-cell00-rule]
#Macro(t4-Sale_Hacia_Adelante)
#Macro(t4-Llega_Desde_Cruce)
#Macro(t4-Default)

[t4-segment1-cell0n-rule]
#Macro(t4-Sale_Hacia_Consumidor)
#Macro(t4-Llega_Desde_Atras)
#Macro(t4-Default)

[t4-segment1-lane0-rule]
#Macro(t4-Llega_Desde_Atras)
#Macro(t4-Sale_Hacia_Adelante)
#Macro(t4-Default)

[t5-segment1-cell00-rule]
#Macro(t5-Sale_Hacia_Adelante)
#Macro(t5-Llega_Desde_Cruce)
#Macro(t5-Default)

[t5-segment1-cell0n-rule]
#Macro(t5-Sale_Hacia_Consumidor)
#Macro(t5-Llega_Desde_Atras)
#Macro(t5-Default)

[t5-segment1-lane0-rule]
#Macro(t5-Llega_Desde_Atras)
#Macro(t5-Sale_Hacia_Adelante)
#Macro(t5-Default)

[t3-segment1-cell0n-semaforo-rule]
#Macro(t3-Sale_Hacia_Cruce_conSemaforo)
#Macro(t3-Llega_Desde_Atras)
#Macro(t3-Default)

[t3-segment1-cell00-rule]
#Macro(t3-Sale_Hacia_Adelante)
#Macro(t3-Llega_Desde_Generador)
#Macro(t3-Default)

[t3-segment1-cell0n-rule]
#Macro(t3-Sale_Hacia_Cruce)
#Macro(t3-Llega_Desde_Atras)
#Macro(t3-Default)

[t3-segment1-lane0-rule]
#Macro(t3-Llega_Desde_Atras)
#Macro(t3-Sale_Hacia_Adelante)
#Macro(t3-Default)

[c2-cellIn-rule]
rule : {1 + send(1, y-t-haylugar)}  12 { (0,0) = 0 and ( (0,-1) = 1 or portvalue(x-t-hayauto) = 1 ) }
rule : {0 + send(0, y-t-haylugar)}  12 { (0,0) = 1 and (0,1) = 0 and (0,-1) = 0 }
rule : {0 + send(1, y-t-haylugar)}  12 { (0,0) = 1 and (0,1) = 0 and (0,-1) = 1 }
#Macro(c2-Default)

[c2-cellOut-rule]
rule : {1 + send(0, y-t-hayauto)}  12 { (0,0) = 0 and (0,-1) = 1 and ( portvalue(x-t-haylugar) = 1 or (portvalue(x-t-haylugar) = 0 and random < 112)}
rule : {0 + send(1, y-t-hayauto)}  12 { (0,0) = 0 and (0,-1) = 1 and portvalue(x-t-haylugar) = 0 and random >= 112 }
rule : {0 + send(0, y-t-hayauto)}  12 { (0,0) = 1 and (0,1) = 0 }
rule : {(0,0) + send(0, y-t-hayauto)}  12 { t }

