#ifndef __TEMPLATENAME_H
#define __TEMPLATENAME_H

#include <string>
#include "segment.h"
#include "crossing.h"
#include "jobsite.h"
#include "ctrelem.h"
#include "hole.h"

//forward declarations
class Segment;
class Crossing;
class Jobsite;
class CtrElem;
class Hole;


class TemplateName
{
public:
  string getTNSegment (Segment *);
  string getTNSegmentStart (Segment *);
  string getTNSegmentEnd (Segment *);
  string getTNSegmentTL (Segment *);
  string getTNCrossing ();
  string getTNCrossingTL ();
  string getTNCrossingHole (Crossing *);
  string getTNJobsite (Jobsite *);
  string getTNHole (Hole *);
  string getTNCtrElem (CtrElem *);
  string getTNRail (Segment *);
  string getTNSincroRailnet ();
  string getTNTop ();

protected:
private:
};


#endif	/* __TEMPLATENAME_H */
