#include "ruleblock.h"

void RuleBlock::addRule(string c)    {rules.push_back(c);}
list<string>* RuleBlock::getRules()  {return &rules;}

bool RuleBlock::getIsDependent(){
//no debe haber % en las reglas ni en las macros que use
list<string>::iterator   iter;
string macroName;
bool isDependent=false;
if (this->rules.size() != 0)
  for (iter = this->rules.begin(); iter != this->rules.end()&&!isDependent; iter++){
       isDependent= ((*iter).find("%")!= string::npos);
       if (!isDependent && (macroName=getMacroName(*iter)) != "")
           isDependent = codeStruct.getMacro(macroName)->getIsDependent();
  }
return isDependent;
}

void RuleBlock::setWasUsed(bool b){wasUsed = b;}
bool RuleBlock::getWasUsed(){return wasUsed;}


void RuleBlock::print(){
list<string>::iterator   iter;
cout << "   RuleBlock ";
if(getIsDependent()) cout <<"dependent\n";else cout <<"not dependent\n";

if (this->rules.size() != 0)
  for (iter = this->rules.begin(); iter != this->rules.end(); iter++)
         cout << "      " << *iter ;
}
