#include <iostream.h>
#include "macro.h"

std::string Macro::getName()          {return name;}
void Macro::setName(std::string c)    {name = c;}
void Macro::addLine(std::string c)    {lines.push_back(c);}
std::list<std::string>* Macro::getLines()  {return &lines;}

bool Macro::getIsDependent()   {
std::list<std::string>::iterator   iter;
bool isDependent=false;
if (this->lines.size() != 0)
  for (iter = this->lines.begin(); iter != this->lines.end()&&!isDependent; iter++)
       isDependent= ((*iter).find("%")!= std::string::npos);
return isDependent;
}

void Macro::setWasUsed(bool b){wasUsed = b;}
bool Macro::getWasUsed(){return wasUsed;}

void Macro::print(){
std::list<std::string>::iterator   iter;
cout << "   Macro " << this->name <<"\n";
if (this->lines.size() != 0)
  for (iter = this->lines.begin(); iter != this->lines.end(); iter++)
         cout << "      " << *iter ;
}
