#include <iostream.h>
#include "ruleblock.h"

void RuleBlock::addRule(std::string c)    {rules.push_back(c);}
std::list<std::string>* RuleBlock::getRules()  {return &rules;}

bool RuleBlock::getIsDependent(){
//no debe haber % en las reglas ni en las macros que use
std::list<std::string>::iterator   iter;
std::string macroName;
bool isDependent=false;
if (this->rules.size() != 0)
  for (iter = this->rules.begin(); iter != this->rules.end()&&!isDependent; iter++){
       isDependent= ((*iter).find("%")!= std::string::npos);
       if (!isDependent && (macroName=getMacroName(*iter)) != "")
           isDependent = codeStruct.getMacro(macroName)->getIsDependent();
  }
return isDependent;
}

void RuleBlock::setWasUsed(bool b){wasUsed = b;}
bool RuleBlock::getWasUsed(){return wasUsed;}


void RuleBlock::print(){
std::list<std::string>::iterator   iter;
cout << "   RuleBlock ";
if(getIsDependent()) cout <<"dependent\n";else cout <<"not dependent\n";

if (this->rules.size() != 0)
  for (iter = this->rules.begin(); iter != this->rules.end(); iter++)
         cout << "      " << *iter ;
}
