|--template SincroRailNet --|
|--top components--|
components : &IDENTIF&
components : &IDENTIF&Gen@Generator 
|--top links--|
link : out@&IDENTIF&Gen x_ge_train@&IDENTIF&
|--before neighbors--|

[&IDENTIF&]
type : cell
Width : &(SEGMENTS)&
Height : 1
delay : transport
defaultDelayTime : 30000
border : nowrapped 
|--neighbors--|
neighbors : &IDENTIF&(0,-1) &IDENTIF&(0,0) &IDENTIF&(0,1)  
|--before ports--|
initialvalue : 0
|--ports--|
in : x_ge_train 
in : x_t_train_bt&#SEGMENTS&
in : x_t_train_at&#SEGMENTS&
out : y_t_train_bt&#SEGMENTS& 
out : y_t_train_at&#SEGMENTS& 
|--links--|
link : x_ge_train x_ge_train@&IDENTIF&(0,0) 
link : x_t_train_bt&#SEGMENTS& x_t_train_bt@&IDENTIF&(0,&#SEGMENTS&)
link : x_t_train_at&#SEGMENTS& x_t_train_at@&IDENTIF&(0,&#SEGMENTS&)
link : y_t_train_bt@&IDENTIF&(0,&#SEGMENTS&) y_t_train_bt&#SEGMENTS&
link : y_t_train_at@&IDENTIF&(0,&#SEGMENTS&) y_t_train_at&#SEGMENTS&
|--before zones--|
portInTransition : x_ge_train@&IDENTIF&(0,0) IngresaTren-rule
portInTransition : x_t_train_bt@&IDENTIF&(0,&#SEGMENTS&) AvisaPasaTren-before-rule
portInTransition : x_t_train_at@&IDENTIF&(0,&#SEGMENTS&) AvisaPasaTren-after-rule
localtransition : pasa-tren-rule

|--rules--|
[IngresaTren-rule]
rule :  1      30000  { (0,0) = 0 and portvalue(x_ge_train) = 1 } 
rule : {(0,0)} 30000  { t } 

[pasa-tren-rule]
rule : { 2 }   30000  { (0,0) = 1 } 
rule : { 0 + send(y_t_train_bt,0) + send(y_t_train_at,0)}     0  { (0,0) = 2 } 
rule : { 1 }   30000  { (0,-1) = 1 } 
rule : {(0,0)} 30000  { t } 

[AvisaPasaTren-before-rule]
rule : {(0,0) + send(y_t_train_bt,(0,0))} 0 { (0,0) = 0 } 
#Macro(Default)

[AvisaPasaTren-after-rule]
rule : {(0,0) + send(y_t_train_at,(0,0))} 0 { (0,0) = 0 } 
#Macro(Default)

|--after rules--|

[&IDENTIF&Gen]
distribution : constant
value : 180
initial : 1
increment : 0

|--end template--|
