#ifndef __TEMPLATENAME_H
#define __TEMPLATENAME_H

#include <string>
#include "segment.h"
#include "crossing.h"
#include "jobsite.h"
#include "ctrelem.h"
#include "hole.h"

//forward declarations
class Segment;
class Crossing;
class Jobsite;
class CtrElem;
class Hole;


class TemplateName {
public:
    std::string    getTNSegment(Segment*);
    std::string    getTNSegmentStart(Segment*);
    std::string    getTNSegmentEnd(Segment*);
    std::string    getTNSegmentTL(Segment*);
    std::string    getTNCrossing();
    std::string    getTNCrossingTL();
    std::string    getTNCrossingHole(Crossing*);
    std::string    getTNJobsite(Jobsite*);
    std::string    getTNHole(Hole*);
    std::string    getTNCtrElem(CtrElem*);
    std::string    getTNRail(Segment*);
    std::string    getTNSincroRailnet();


protected:
private:
};

#endif /* __TEMPLATENAME_H */
