#ifndef __MACRO_H
#define __MACRO_H

#include <list>
#include <string>

class Macro{
public:
    void print();               //print all the info to the stdin  
    std::string getName();
    void setName(std::string);
    void addLine(std::string c);
    std::list<std::string>* getLines();
    bool getIsDependent();
    bool getWasUsed();
    void setWasUsed(bool);
 
protected:
    std::string       name;
    std::list<std::string> lines;  
    bool         wasUsed;
private:
};

#endif /* __MACRO_H */
